;                          12864J-2FLA           

	list      p=16f873         ; list directive to define processor
	radix	hex
	#include <p16f873.inc>     ; processor specific variable definitions
      __CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _WRT_ENABLE_ON & _LVP_OFF & _DEBUG_OFF & _CPD_OFF 
ColStolb     	equ	0x20	; col. stolbcov in 1 controller - 64dec  
ColPage		equ	0x21	; col. stranic - 8    
tmp1		equ	0x22	;     1    
tmp2		equ	0x23	;     2       
tmp3		equ	0x24	;     3    
tmp4		equ	0x25	;     4 
DataADCl                equ	0x26	;     5    
DataADCh	equ	0x27	;     6
kX		equ	0x28
DAN                        equ	0x29         ;        
ADR                        equ	0x2A         ;    FSR
DataTzl                    equ	0x2B         ;   DataTz1    
DataTz2                   equ	0x2C        ;   DataTz2   
DecTz1                    equ	0x2D
DecTz2                    equ	0x2E         ;   
EEDATA  	equ           0x10C       ;    
EEADR	                equ           0x10D       ;    EEPROM
EECON1                 equ	0x18C       ; 
EECON2                 equ	0x18D       ;   
;================================================================================
		ORG     0x000             ; processor reset vector -      
		clrf    PCLATH            ; ensure page bits are cleared -  
  		goto    main              ; go to beginning of program
		ORG     0x004             ; interrupt vector location
 main  
                	bcf	STATUS,RP1		;bank 0, Adjustment PORT  
		bcf	STATUS,RP0		;
		clrf	PORTA
		clrf	PORTB
		clrf	PORTC
		bsf	STATUS,RP0	        	;  1
		movlw	B'00000111'	                ;      
		movwf	ADCON1			; 
		clrf	TRISA			; RA0,1,2,3,4,5 
		movlw	B'11100000'		;RB5,6,7 < in, RB0,1,2,3,4 > out , RB5-  
		movwf	TRISB			;
		movlw	0		        	;RC0-7 -> out (data LCD)        
		movwf	TRISC			;
		movlw	B'00000111'		;osc+prDel+TMR0, Kpd=256,RB<podtRezist
		movwf	OPTION_REG		;
		clrf	PIE1                                         ;  
		bcf 	STATUS,RP0 	                ;  0
		clrf	T1CON                   ;  1  
		clrf	INTCON                  ;  
		bsf	PORTB,2	        	;Reset LCD OFF, 
		call	tay3
		movlw	B'00000101'             ; 
		movwf	kX		;
                  movlw       0x1                                      ;                           
                  movwf    DataTz2       ;   
                  movlw       0x17
                  movwf    DataTzl       ;   
		call	tay3
                	bcf	STATUS,RP1		;bank 0, Adjustment PORT  
		bcf	STATUS,RP0		;
		call	R0			;   EEPROM
		call	Reset			;  
                               CALL       DISPL
		call	tay3
WP           ; ==============================    =================
        CALL    tay3                                             ;
         BTFSS   PORTB,7                                    ;    /  RB7/ 
        GOTO     G1                                              ;  
        BTFSS   PORTB,6                                     ;    /  RB6/ 
        GOTO    NF                                              ;   
        BTFSS   PORTB,5                                     ;   /  RB5/ 
        GOTO    G7                                               ; 
        GOTO     WP                                            ;  
NF    ; ==============================       ==============================
        CALL     tay3                                             ;
        CALL     tay3                                             ;
        CALL     tay3                                             ;
         BTFSS   PORTB,7                                    ;    /  RB7/ 
        GOTO     UWF                                          ;   
        BTFSS   PORTB,6                                     ;    /  RB6/ 
        GOTO    UMF                                           ;   
        BTFSS   PORTB,5                                     ;   /  RB5/ 
        GOTO    G7                                               ; 
        GOTO      NF                                            ;  
NF1   ; ==============================       ==============================
        CALL     tay3                                             ;
        CALL     tay3                                             ;
        CALL     tay3                                             ;
         BTFSS   PORTB,7                                    ;    /  RB7/ 
        GOTO     G71                                            ;  
        BTFSS   PORTB,6                                     ;    /  RB6/ 
        GOTO    UMF                                           ;   
        BTFSS   PORTB,5                                     ;   /  RB5/ 
        GOTO    G71                                                ; 
        GOTO      NF1                                           ;  
NF2    ; ==============================       ==============================
        CALL     tay3                                             ;
        CALL     tay3                                             ;
         BTFSS   PORTB,7                                    ;    /  RB7/ 
        GOTO     UWF                                          ;   
        BTFSS   PORTB,6                                     ;    /  RB6/ 
        GOTO    UMF1                                           ;   
        BTFSS   PORTB,5                                     ;   /  RB5/ 
        GOTO    G7                                               ; 
        GOTO      NF2                                            ;  
UWF     ;   =====================================
                  	call	tay3                    ; 
	                decfsz	DataTzl,F                                 ;  = 0,     incfsz DataTzl,F	
		goto 	NF
  		incfsz	DataTzl,F			;  +1  . DataTzl,  
		decfsz	DataTz2,F                                 ;  = 0,    incfsz DataTz2,F
 		goto         NF
  		incfsz	DataTz2,F			;  +1  . DataTz2,  
 		goto         G71                                             ;   
UMF      ;   =====================================
                  	call	tay3                    ; 
  		incfsz	DataTzl,F			;  +1  . DataTzl,   DataTzl=FF     movlw  0x1 
 		goto          NF 
                                movlw       0x1
                                movwf    DataTzl       ;
                                movlw       0xff                              ; 
                                movwf    DataTz2       ;
 		goto          NF2
UMF1      ;   =====================================
                  	call	tay3                    ; 
  		incfsz	DataTzl,F			;  +1  . DataTzl,   DataTzl=FF    G7 
 		goto          NF2 
 		goto         G7                                             ; 
R0               ; ==========================   R ======================
          bsf		STATUS,RP1        ; 
          bcf  	STATUS,RP0        ;  2
          clrf                 EEADR                ;  10D     EEPROM
          movlw	0xA0                    ; 0=160 -     
          movwf	FSR	            ; FF=256 -      1 
R1
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;  R  
	BSF	EECON1,RD           ;  .
	BCF	STATUS,5           ;    2.
         MOVFW        EEDATA               ;   EEDATA  ( 10 )  FSR
         MOVWF        INDF                     ; 
         INCF            EEADR,1                 ;    1  R
         incfsz            FSR,F	             ; +1,   FSR=FF    movlw	0x60
         GOTO          R1
		movlw	0x60			; 80=128 -      0 
		movwf	FSR			;    0  128-96=32 
R2
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;  R  
	BSF	EECON1,RD         ;  .
	BCF	STATUS,5             ;    2.
         MOVFW        EEDATA               ;   EEDATA  ( 10 )  FSR
         MOVWF        INDF                     ; 
         INCF            EEADR,1                 ;    1  R
         incf	             FSR,F			;next adr.RAM
         btfss             FSR,7                       ; +1,  FSR=80    G1 ( 7 =1 )
         GOTO          R2
		return
G1   ;   ==========================  ======================================================
		clrf           DAN
		bcf	STATUS,IRP		;  1
                               MOVLW   0xA0        ; A0-    
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0                                        ;    B FSR
		movwf	FSR			; FF=256 -     
G2
                  	call	tay3                    ; 
        BTFSS   PORTB,7                                    ;    /  RB7/ 
        GOTO     G3                                             ;     DAN
        BTFSS   PORTB,6                                   ;    /  RB6/ 
        GOTO    UWA1                                       ;  UWA1- 
        BTFSS   PORTB,5                                   ;   /  RB5/ 
        GOTO    G7                                             ; 
        GOTO     G2                                            ;  
G3
                                INCF       DAN,1                                      ; +1  .DAN
		btfss	DAN,6			;  DAN=65   DAN (   =1 )
                               GOTO       G31
		clrf           DAN
G31
                               MOVF     ADR,0                                        ;    B FSR
		movwf	FSR			; 
                                movf	DAN,W                                   ;
		movwf	INDF			;    
		call	Reset			;  
                               CALL       DISPL
                               GOTO       G2
G4
                               MOVLW   0x60        ; 60-      0
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0                                        ;    B FSR
		movwf	FSR			; FF=256 -     
G5
                 	call	tay3                    ; 
        BTFSS   PORTB,7     ;    / RB7/ 
        GOTO              G6               ;   DAN
        BTFSS   PORTB,6     ;    / RB6/ 
        GOTO    UWA2         ; UWA2- 
        BTFSS   PORTB,5                                   ;    /  RB5/ 
        GOTO    G7                                             ; 
        GOTO     G5                                            ;  
G6
                                INCF       DAN,1                                      ; +1  .DAN
		btfss	DAN,6			;  DAN=65    DAN (   =1 )
                               GOTO       G61
		clrf           DAN
G61
                               MOVF     ADR,0                                        ;    B FSR
		movwf	FSR			; 
                                movf	DAN,W                                   ;
		movwf	INDF			;    
		call	Reset			;  
                               CALL       DISPL
                               GOTO       G5
 UWA1                              ;  ----------------------------------------------
		call	tay3			;
                  	call	tay3                    ; 
		clrf          DAN
  		incfsz	ADR,F			;  +1  .ADR,   FSR=FF    G4
 		goto         G2 
 		goto         G4  
 UWA2                              ;  -------------------------------------
		call	tay3			;
                  	call	tay3                                          ; 
		clrf          DAN
                                INCF       ADR
		btfss	ADR,7			; +1  .ADR,     FSR=80    G1 ( 7 =1 )
 		goto         G5  
 		goto         G1
Reset     ;============================  ============================
                	bcf	STATUS,RP1		;bank 0, Adjustment PORT  
		bcf	STATUS,RP0		;
                                bsf	PORTB,0		        ;E1<-1          - .  
		bsf	PORTB,1		        ;E2<-1
		call	tay1
		bcf	PORTB,2		        ;impuls Reset		
		call	tay1
		bsf	PORTB,2		        ;end impuls
		call	tay1
;--------- display ON -------------
		bcf	PORTB,4		        ;E<-0
		bcf	PORTB,3		        ;A0<-0,
		nop
		movlw	B'00111111'	        ;3F -  data Display <- ON
		movwf	PORTC		        ;
		call	tay1
		bsf	PORTB,4   	        ;E<-1, enable write
		call	tay1
		bcf	PORTB,4		        ;E<-0, end write
		clrf	PORTC
		call	tay1
clrScr    ;========== clear screen ===============   =================
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;         	
		movlw	0x40			;number stolbcov in 1 controller
		movwf	ColStolb		;40h -> 64dec        .  = 64
		clrf	ColPage			;col. stranic
	                bcf	PORTB,1	        	;E2<-0
		nop
		bsf	PORTB,0		        ;E1<-1, 1 crystal
		nop
clrNextPg                 movf	ColPage,W		;number page    -  
		movwf	PORTC			;set page
		call	setPage
		clrf	PORTC			;set stolb <- 0 -   
		call	setColon
clrNext		clrf	PORTC			;data<-0
		call	wrBit
		decfsz	ColStolb,F
		goto	clrNext			;next stolb
		movlw	0x40			; 40h = 64dec
		movwf	ColStolb
		incf	ColPage,F
		btfss	ColPage,3
		goto	clrNextPg		;ColPage<8, Next page		
		btfss	PORTB,0			;ColPage=8, end crystal  ?
		goto	endScr			;E1=0
		bcf	PORTB,0		        ;E1=1, E1<-0
		bsf	PORTB,1		        ;E2<-1, 2 crystal ON
		clrf	ColPage
		goto	clrNextPg
endScr                      bsf	PORTB,0			;E1<-1, screen ON
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;   
		call	tay3
		return
DISPL
; ======== RAM -> Screen ======        1   g1  g96 ==========
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		clrf	PORTC
		bcf	PORTB,1		        ;E2<-0              .2 
		bsf	PORTB,0		        ;E1<-1, 1 crystal - .1 
		call	tay1
		movlw	0x40			;number stolbcov in 1 controller
		movwf	ColStolb		;40h = 64dec         
 		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		movlw	B'01000000'		;set stolb <- 0,  0 
		movwf	PORTC			;
		bsf	PORTB,4	        	;E<-1, enable write,  ,()
		call	tay1
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		bcf	STATUS,IRP		;bank 0,1 (kocv. adr.)
		movlw	0xA0                    ; 0 -     1
		movwf	FSR			;start adr.RAM(bank 1)
nextStolb1     	movf	INDF,W                  ;-----------   .  W-------------------
                                movwf     DataADCh
                                comf	DataADCh,F	        ;invert	- (       )	
		movlw	B'00111111'     	; 
		andwf	DataADCh,F	        ;high 6 bit	
                                movf	DataADCh,W              ;
                                movwf	DataADCl		;dataRAM->DataADCl
;------- nomer stranicy ---     
		movwf	DataADCh
		rrf	DataADCh,F              ;   
		rrf	DataADCh,F
		rrf	DataADCh,F	        ;nomer stranicy
		movlw	B'00000111'             ;  , w f
		andwf	DataADCh,W		;select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		;N page - 0 ( =8 ,,,F)
		iorwf	PORTC,F                 ;   W  F,    
 		bcf	PORTB,4		        ;write -   
		bcf	PORTB,3		        ;  
		nop
		bsf	PORTB,4		        ;E<-1, enable write-. 1  - ()
		call	tay1
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
;-------- data -> screen ------      
		movlw	B'00000111'             ; 
		andwf	DataADCl,F		;data page -     W 
		movlw	B'00000001'
		movwf	tmp1
sdvig1         	movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr1		;DataADCl=0
		decf	DataADCl,F		;DataADCl>0
		bcf	STATUS,C
		rlf	tmp1,F                  ;   
		goto	sdvig1
writScr1       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		bcf	PORTB,4		        ;
		bcf	PORTB,3		        ;  
		call	tay1
		bsf	PORTB,3		        ;A<-1, write screen - 0=1 -    
		nop
		bsf	PORTB,4		        ;E<-1, enable wr.screen - 
		call	tay1
		bcf	PORTB,4		        ;E<-0 -    
		call	tay1
                                bcf	PORTB,3		        ;A<-0 0=0 - . 
		incf	FSR,F			;next RAM(bank 1)
		decfsz	ColStolb,F		;control end crystal
		goto	nextStolb1		;next stolb(bank 1)
		bcf	PORTB,0		        ; . 1 
;---------------------------------    1   g 65  g 96     2    ----------------------------------------------
		bsf	PORTB,1		        ; . 2 
		call	tay1
nextStolb2     	movf	INDF,W
                	movwf     DataADCh
                                comf	DataADCh,F	        ;invert	- (       )	
		movlw	B'00111111'	        ; 
		andwf	DataADCh,F	        ;high 6 bit	
               	                movf	DataADCh,W              ;
		movwf	DataADCl		;dataRAM->DataADCl
;------- nomer stranicy --------
		movwf	DataADCh
		rrf	DataADCh,F
		rrf	DataADCh,F
		rrf	DataADCh,F      	;nomer stranicy
		movlw	B'00000111'
		andwf	DataADCh,W		;select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		;N page - 0
		iorwf	PORTC,F
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ;  
		nop
		bsf	PORTB,4		        ;E<-1, enable write - .   
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
;-------- data -> screen ------      
		movlw	B'00000111'
		andwf	DataADCl,F		;data page
		movlw	B'00000001'
		movwf	tmp1
sdvig2                       movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr2		;DataADCl=0
		decf	DataADCl,F		;DataADCl>0
		bcf	STATUS,C
		rlf	tmp1,F
		goto	sdvig2
writScr2       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		nop
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,3		        ;A<-1, write screen
		nop
		bsf	PORTB,4		        ;E<-1, enable wr.screen - .   
		call	tay1
		bcf	PORTB,4		        ;E<-0
		call	tay1
		decf	ColStolb,F	
		incfsz	FSR,F			;next RAM(bank 1)
		goto	nextStolb2		;next stolb(bank 1)
;------- next bank 0 ->crystal 2 -        0   2     g97    g128
		movlw	0x60			;FSR=0(adr=0),->bank 0
		movwf	FSR			;start adr.RAM(bank 0)
nextStolb3     	movf	INDF,W
                 	movwf     DataADCh
	                comf	DataADCh,F      	;invert	- (       )	
		movlw	B'00111111'	        ; 
		andwf	DataADCh,F      	;high 6 bit	
                                movf	DataADCh,W              ;
		movwf	DataADCl		;dataRAM->DataADCl
;------- nomer stranicy --------
		movwf	DataADCh
		rrf	DataADCh,F
		rrf	DataADCh,F
		rrf	DataADCh,F	        ;nomer stranicy
		movlw	B'00000111'
		andwf	DataADCh,W		;select bit(2-0),number
		movwf	PORTC			;
		movlw	B'10111000'		;N page - 0
		iorwf	PORTC,F
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ; 
		nop
		bsf	PORTB,4		        ;E<-1, enable write -  
		call	tay1
		bcf	PORTB,4		        ; write
		bcf	PORTB,3		        ; 
;-------- data -> screen -----------     
		movlw	B'00000111'
		andwf	DataADCl,F		;data page
		movlw	B'00000001'
		movwf	tmp1
sdvig3         	movf	DataADCl,F
		btfsc	STATUS,Z
		goto	writScr3		;DataADCl=0
		decf	DataADCl,F		;DataADCl>0
		bcf	STATUS,C
		rlf	tmp1,F
		goto	sdvig3
writScr3       	movf	tmp1,W				
		movwf	PORTC			;
		nop
		nop
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,3		        ;A<-1, write screen
		nop
		bsf	PORTB,4		        ;E<-1, enable wr.screen  
		call	tay1
		bcf	PORTB,4		        ;E<-0
		call	tay1
		decf	ColStolb,F
		incf	FSR,F			;next RAM 0bank
		btfss	FSR,7
		goto	nextStolb3		;next stolb(bank 0)
		bsf	PORTB,0		        ;1 crystal-> screen
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		return
wrBit     ;========= write bit to screen (PORTC <- Data)      
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 	
		call	tay1
		call	tay1
		bsf	PORTB,3			;A<-1, write screen
		call	tay1
		bsf	PORTB,4			;E<-1, enable wr.screen
		call	tay1
		call	tay1
		bcf	PORTB,4			;E<-0
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; set Stolb
		call	tay1
		return
setColon  ;========== set Colonky (PORTC,(5-0) <- adres Colon.(0-63))  
		bsf	PORTC,6			;set Colonky(stolbec),   
		call	tay1                    ;(bsf PORTC,6=40-0 ,   clrf PORTC)
		bsf	PORTB,4			;E<-1, enable write, 
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		return
setPage   ; ======= set Page (PORTC,(2-0) <- Number Page (0-7))  
		movlw	B'10111000'		;Set page 8 -  
		iorwf	PORTC,F                 ;  W  F    
		nop                             ;     
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		bsf	PORTB,4			;E<-1, enable set, 
		call	tay1
		bcf	PORTB,4		        ; 
		bcf	PORTB,3		        ; 
		call	tay1
		return
tayPusk ; ==============================    ==============      
		movf	DataTz2,W
		movwf	DecTz2
tayP2	                movf	DataTzl,W
		movwf	DecTz1
tayP1	                decfsz	DecTz1,F
		goto 	tayP1
		decfsz	DecTz2,F
		goto	tayP2
		return
tay1    ; =========== Pouse - long t shim1 ======  ,     10 ..
                                movlw	0x07
		movwf	tmp3
looptay1                   decf	tmp3,F
		nop
		btfss	STATUS,Z
		goto	looptay1
		return
tay3     ; ============ Pouse - long3 ===========  
                	movlw	0xFF
		movwf	tmp3
looptay3       	movlw	0xFF
		movwf	tmp4
looptmp3       	decf	tmp4,F
		btfss	STATUS,Z
		goto	looptmp3
		decf	tmp3,F
		btfss	STATUS,Z
		goto	looptay3
		return
G7            ; ==============================   R =================================
              bsf	  STATUS,RP1            ;  2
              bcf	  STATUS,RP0	             ; 
              clrf	  EEADR                     ;  10D
E0                                                        ; ==================================
          movlw	0xA0                    ; 0=160 -     
          movwf	FSR			; FF=256 -      1 
E1
        MOVFW        INDF                      ;   FSR  EEDATA
         MOVWF        EEDATA               ;  10
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;    
         BSF	               EECON1, WREN   ;    R  
         BCF               INTCON, GIE         ;  
         MOVLW       0x55                         ;  55h   N2
         MOVWF       EECON2                  ;
         MOVLW       0xAA                       ;  h   2  
         MOVWF       EECON2 
         BSF	              EECON1, WR          ;       41C
         BTFSC          EECON1,1               ;  .
         GOTO           $-1                           ;
         BCF              STATUS,5               ;   2.
         INCF            EEADR,1                 ;    1  R
         incfsz            FSR,F	             ; +1,   FSR=FF    movlw	0x60
         GOTO          E1
		movlw	0x60			; 80=128 -      0 
		movwf	FSR			;    0  128-96=32 
E2
        MOVFW         INDF                     ;   FSR  EEDATA
         MOVWF        EEDATA               ;  10
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;  R  
         BSF	               EECON1, WREN   ;    R  
         BCF               INTCON, GIE         ;  
         MOVLW       0x55                         ;  55h   N2
         MOVWF       EECON2                  ;
         MOVLW       0xAA                       ;   h   2  
         MOVWF       EECON2 
         BSF	              EECON1, WR          ;       41C
         BTFSC          EECON1,1               ;  .
         GOTO           $-1                           ;
         BCF              STATUS,5               ;   2.
         INCF            EEADR,1                 ;    1  R
         incf	             FSR,F			;next adr.RAM
         btfss             FSR,7                       ; +1,  FSR=80    G1 ( 7 =1 )
         GOTO          E2
G8             ; ==============================  =================================
                	bcf	STATUS,RP1		; bank 0
		bcf	STATUS,RP0		;
G88
                               MOVLW   0xA0        ; A0-      1 
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0        ;   B FSR
		movwf	FSR	 ; FF=256 -     
G9
                              MOVF    INDF,0          ;   FSR   A          
                              MOVWF   PORTA      ;
                              CALL    tayPusk         ;
		incfsz	FSR,F	 ; +1  .ADR,   FSR=FF      MOVLW   0x60
                               GOTO    G9 
        BTFSS   PORTB,7                                     ;   /  RB7/ 
        GOTO    NF                                              ; NF 
                               MOVLW   0x60         ; 60-      0
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0        ;   B FSR
		movwf	FSR	 ;   
G10
                               MOVF    INDF,0           ;   FSR   A          
                               MOVWF   PORTA       ;
                              CALL    tayPusk                     ;
		incf	FSR,F			;next RAM 0bank
		btfss	FSR,7			; +1  .ADR,     FSR=80 ( 7 =1 )    G8  
                                GOTO    G10
                                GOTO    G88

G71            ; ==============================   R =================================
              bsf	  STATUS,RP1            ;  2
              bcf	  STATUS,RP0	             ; 
              clrf	  EEADR                     ;  10D
E01                                                        ; ==================================
          movlw	0xA0                    ; 0=160 -     
          movwf	FSR			; FF=256 -      1 
E11
        MOVFW        INDF                      ;   FSR  EEDATA
         MOVWF        EEDATA               ;  10
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;    
         BSF	               EECON1, WREN   ;    R  
         BCF               INTCON, GIE         ;  
         MOVLW       0x55                         ;  55h   N2
         MOVWF       EECON2                  ;
         MOVLW       0xAA                       ;  h   2  
         MOVWF       EECON2 
         BSF	              EECON1, WR          ;       41C
         BTFSC          EECON1,1               ;  .
         GOTO           $-1                           ;
         BCF              STATUS,5               ;   2.
         INCF            EEADR,1                 ;    1  R
         incfsz            FSR,F	             ; +1,   FSR=FF    movlw	0x60
         GOTO          E11
		movlw	0x60			; 80=128 -      0 
		movwf	FSR			;    0  128-96=32 
E21
        MOVFW         INDF                     ;   FSR  EEDATA
         MOVWF        EEDATA               ;  10
          bsf		STATUS,RP1        ;  3
          bsf		STATUS,RP0
         BCF               EECON1, EEPGD  ;  R  
         BSF	               EECON1, WREN   ;    R  
         BCF               INTCON, GIE         ;  
         MOVLW       0x55                         ;  55h   N2
         MOVWF       EECON2                  ;
         MOVLW       0xAA                       ;   h   2  
         MOVWF       EECON2 
         BSF	              EECON1, WR          ;       41C
         BTFSC          EECON1,1               ;  .
         GOTO           $-1                           ;
         BCF              STATUS,5               ;   2.
         INCF            EEADR,1                 ;    1  R
         incf	             FSR,F			;next adr.RAM
         btfss             FSR,7                       ; +1,  FSR=80    G1 ( 7 =1 )
         GOTO          E21
G81             ; ==============================  =================================
                	bcf	STATUS,RP1		; bank 0
		bcf	STATUS,RP0		;
G82
                               MOVLW   0xA0        ; A0-      1 
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0        ;   B FSR
		movwf	FSR	 ; FF=256 -     
G91
                              MOVF    INDF,0          ;   FSR   A          
                              MOVWF   PORTA      ;
		incfsz	FSR,F	 ; +1  .ADR,   FSR=FF      MOVLW   0x60
                               GOTO    G91 
        BTFSS   PORTB,7                                     ;   /  RB7/ 
        GOTO    NF1                                              ; NF1 
                               MOVLW   0x60         ; 60-      0
                               MOVWF   ADR         ;   .ADR
                               MOVF     ADR,0        ;   B FSR
		movwf	FSR	 ;   
G101
                               MOVF    INDF,0           ;   FSR   A          
                               MOVWF   PORTA       ;
		incf	FSR,F			;next RAM 0bank
		btfss	FSR,7			; +1  .ADR,     FSR=80 ( 7 =1 )    G82  
                                GOTO    G101
                                GOTO    G82
		    END                             ; 
